	.include "code\\startup.s"


	.text

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	.extern	olp2set		; objectlist pointer...
	.extern	gSetOLP		; routine for setting OLP
	.extern	ticks		; video stuff...
	.extern	a_vdb
	.extern	a_vde
	.extern	a_hdb
	.extern	a_hde
	.extern	width
	.extern	height

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

bitmap_addr		.equ	$20000	; Buffer in main memory
BM_WIDTH		.equ	640	; Bitmap width in pixels
BM_HEIGHT		.equ	480	; Bitmap height in pixels (was 199)
BM_DEPTH		.equ	16	; 16 bits per pixel
BM_PHRASES		.equ	((BM_WIDTH*BM_DEPTH)/64)	; phrase = 64 bits
BM_OFFSET	  	.equ    (2*8)	; Two Phrases

MY_LISTSIZE	.equ	5	; List size in phrases:		
							; branch (1)
							; branch (1)
							; bitmap (2)
							; stop (1)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; This is where we get control after the startup code...

_start::

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	MOVE.w #$100,JOYSTICK
	
	bsr	BPEGInit		; copy over GPU code
	clr.w curnopic
	
	lea picaddrs,a0
	moveq #0,d0
countpics:	
	move.l (a0)+,d1
	blt.s countover
	addq.w #1,d0
	bra.s countpics
	
countover:	move.w d0,nopics

	
loop:
    move.w curnopic,d0
	lea picaddrs,a0
	lsl.w #2,d0
    move.l (a0,d0.w),a0     ;source
    add.l #picaddrs,a0
    lea framebuffer,a1        ;display buffer
	move.l	#((BM_WIDTH*BM_DEPTH)/8),d0	; Width of destination bitmap, in bytes
	bsr	BPEGDecode		; Decode image
.wait_decode:
	tst.l	BPEGStatus		; Wait for decompression to finish
	bmi.s	.wait_decode	; before continuing...

check_pad_loop:
	bsr readpad
	bsr handle_input
	
	move.w dpad_left,d0
	add.w dpad_c,d0
	beq.s check_right
	move.w curnopic,d0
	subq.w #1,d0
	bge.s noleftwrap
	move.w nopics,d0
	subq.w #1,d0
noleftwrap:
	move.w d0,curnopic
	bra loop
	
check_right:	
	move.w dpad_right,d0
	add.w dpad_b,d0
	add.w dpad_a,d0
	beq.s check_pad_loop
	move.w curnopic,d0
	addq.w #1,d0
	cmp.w nopics,d0
	bne.s norightwrap
	moveq #0,d0
norightwrap:
	move.w d0,curnopic
	bra loop
	

	

	include "code\\_joypad.s"

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;bpeg code here
	include "code\\bpeg.s"
	.68000

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	.dphrase

picaddrs:

	.phrase
	.bss
	.dphrase

curpic:	ds.l 1
nopics:	ds.w 1
curnopic: ds.w 1
	.dphrase

	
my_objlist:
	.ds.l	16

ol_update:
	.ds.l	2


joyedge:         ds.l            2
joycur:          ds.l            2

dpad_left:      .ds.w   1
dpad_right:     .ds.w   1
dpad_up:        .ds.w   1
dpad_down:      .ds.w   1

dpad2_b:		.ds.w	1

dpad_b:         .ds.w   1
dpad_a:         .ds.w   1
dpad_c:			.ds.w	1

dpad_number:	.ds.w	1

PAUSE_ON:       .ds.w   1
pawslock:       .ds.w   1

exit_flag:      .ds.w   1

.phrase
framebuffer:    .ds.w   640*480
